' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8250
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   8250
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton go 
      Caption         =   "go"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   7320
      Width           =   4455
   End
   Begin VB.ListBox status 
      Height          =   6885
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cout(s As String)
    status.AddItem s
    status.Refresh
End Sub

Private Sub go_Click()
    cout "begin..."
    
    Dim libsrv As String
    Dim userid As String
    Dim pw As String
    Dim connstr As String
    
    libsrv = "ross"
    userid = "frnadmin"
    pw = "password"
    connstr = "PORT=80;DESAPPID=edms2;DESAPPPW=edms"
    
    Dim dsDES As New DXDatastoreDES

    cout "list servers"
    Dim pCol As DXSequentialCollectionDES
    Set pCol = dsDES.listDataSources
    Dim pIter As DXSequentialIteratorDES
    Set pIter = pCol.createIterator
    
    Dim pSV As DXServerDefDES
    i = 0
    Do While pIter.more
        i = i + 1
        Set pSV = pIter.Next
        strServerName = pSV.getName
        strServerType = pSV.datastoreType
        cout "Server Name [" & i & "] - " & pSV.getName & " Server Type - " & pSV.datastoreType
    Loop
    cout i & " servers listed"

    cout "connecting to datastore"
    dsDES.Connect libsrv, userid, pw, connstr
    cout "datastore connected libsrv: " & libsrv & " userid: " & userid
    
    cout "list entities"
    
    Set pCol = dsDES.listEntities
    Set pIter = pCol.createIterator
    
    Dim pCol2 As DXSequentialCollectionDES
    Dim pIter2 As DXSequentialIteratorDES
    
    Dim pEnt As DXDatabaseDefDES
    Dim pAttr As DXFieldDefDES
    
    i = 0
    Do While pIter.more
        i = i + 1
        
        Set pEnt = pIter.Next
        cout "database name [" & i & "] - " & pEnt.getName
        cout "dispname:  " & pEnt.getDisplayName
        cout "helptext:  " & pEnt.getHelpText
        cout "lang:      " & pEnt.getLanguage
        cout "NumValus:  " & pEnt.getNumVals
        cout "datatype:  " & pEnt.getDataType
        cout "searchable:" & pEnt.isSearchable
        cout "retrievable" & pEnt.isRetrievable

        cout "  list attributes for " & strDBName & " database name"
        
        Set pCol2 = dsDES.listEntityAttrs(pEnt.getName)
        Set pIter2 = pCol2.createIterator
        
        j = 0
        Do While pIter2.more
            j = j + 1
            Set pAttr = pIter2.Next
            cout "    Attribute name [" & j & "] - " & pAttr.getName
            cout "      datastoreName " & pAttr.datastoreName
            cout "      datastoreType " & pAttr.datastoreType
            cout "      type          " & pAttr.getType
            cout "      size          " & pAttr.getSize
            cout "      nullable      " & pAttr.isNullable
            cout "      precision     " & pAttr.getPrecision
            cout "      scale         " & pAttr.getScale
            cout "      string type   " & pAttr.getStringType
            cout "      display name  " & pAttr.getDisplayName
            cout "      help text     " & pAttr.getHelpText
            cout "      language      " & pAttr.getLanguage
            cout "      isQueryable   " & pAttr.isQueryable
            cout "      isRetrievable " & pAttr.isRetrievable
        Loop
        
        cout "  " & j & " attributes listed for " & pEnt.getName & " database name"
    Loop
    cout i & " entities listed\n"
    
    dsDES.disconnect
    cout "datastore disconnected"
   
    cout "done ..."
End Sub
